


								SWEEP FUNCTION
			
;*****************************************************************************************
;               SWEEP function.
;*****************************************************************************************

                BTFSS   SWEEP_STOPPED   ;       Is the sweep running, and is it
                BTFSS   SWEEP_CLOCK     ;       time to change the DDS freq ?
               _GOTO    SWEEP_NO_CNG    ;       N. No change or frequency requred.

FAST_SWP_START:	BTFSS   SWEEP      		;		Sweep mode?
			   _GOTO	NO_TRIGGER		;		N.
				BTFSS   SWEEP_DIR		;       Is the direction down ?		
  			   	BSF		EN_TRIGGER		;		Y.  Set the trigger enable flag.   
NO_TRIGGER:		BTFSS   SWEEP_CLOCK     ;       For fast sweep, wait until its
               _GOTO    FAST_SWP_START  ;       time to change the DDS freq.
                BCF     SWEEP_CLOCK     ;       Y. Clear the sweep clock bit.
                MOVLW   SWP_STEP_SIZE   ;
               _CALL    COPY_TO_ARG3    ; (1)   Get the sweep constant.
                BTFSS   SWEEP_DIR       ;       Is the direction down ?
               _CALL    NEG_ARG3        ; (1)   Y. Make step size negative.
               _CALL    ADD             ; (3)   Inc ARG2 by the step size.
                BCF     SWEEP_CHANGE    ;       Clear the change direction flag.
                BTFSS   SWEEP_DIR       ;       Is the direction down ?
               _CALL    CHK_MIN         ; (3)   Y. Make sure we dont go below ARG4.
 	         	BTFSC   SWEEP_DIR       ;       Is the direction up ?
               _CALL    CHK_MAX         ; (3)   Y. Make sure we dont go above ARG5.
                MOVLW   SWEEP_DIR_MASK  ;
                BTFSC   SWEEP_CHANGE    ;       End of the sweep ?
                XORWF   SWEEP_FLAGS,F   ;       Y. Change the sweep direction.
				BTFSC	WOBBLE			;		Wobble mode?
               _GOTO	SWEEP_NO_CNG	;		Y.   
				BTFSS   SWEEP_DIR       ;		Is the direction down ? 
			   _CALL	ARG4_TO_ARG2	;		Y. Flyback to the start frequency
				BTFSS	SWEEP_DIR		;		Is the direction down ?
			   _CALL	STOP_SWEEP 
SWEEP_NO_CNG:	BTFSS	SWEEP_STOPPED	;		Is the sweep halted?
		       _GOTO	NOT_STOPPED		;		N.
		        BTFSC	SWEEP			;		Y. Sweep mode?
               _CALL	ARG4_TO_ARG2	;		Y. Load the start frequency
		
NOT_STOPPED:   _CALL    CHK_SWEEP_RATE  ; (3)   Chk encoder (inc/dec sweep rate)
               _CALL    ARG2_TO_SF      ; (1)   Save the start or finish frequency.
   			   	BTFSC   EN_TRIGGER		;		Is the trigger enabled?
               _CALL    TRIG_PULSE		;		Y.  
			   _CALL    FREQ_TO_LCD     ; (4)   Update the DDS, and display it.
                                        ;       (don't display it in fast sweep mode)
               _CALL    CHK_KEYPAD      ; (5)   Check for keypad functions.
                                        ;       (no frequency entry)
                BTFSC   FAST_WOBBLE     ;       Are we doing a fast sweep.
               _GOTO    FAST_SWP_START  ;       Y. Repeat the sweep.
                BTFSS   SWEEP_ACTIVE    ;       Is the sweep function active ?
               _GOTO    SET_LIMITS      ;       N. Reset the limits & return to the main loop.
               _GOTO    MAIN_LOOP       ;       Y. Return to the main loop.
               
;-----------------------------------------------------------------------------------------
               
TRIG_PULSE: 	BSF		PORTA,6			;       Trigger pulse positive edge.
	       	  P_CALL	WAIT_8MS
				BCF		PORTA,6			;       Trigger pulse negstive edge.
				BCF		EN_TRIGGER		;		Clear the trigger enable flag
				RETURN


STOP_SWEEP:		BTFSS	SINGLE_SWEEP	;		Single sweep mode?
				RETURN					;		N.
				MOVLW   SWEEP_STP_MASK  ;       Y.  Stop sweeping
                XORWF   SWEEP_FLAGS,F   ;       Change the state of the sweep stopped flag.
				BCF		SINGLE_SWEEP	;		Clear the single sweep flag
				RETURN	
